/*
Copyright (c) 1996 W. Richard Stevens.  All rights reserved.

Revised 1999 Norvin Eitzen to include URL lookup

Revision Dec 1, 1999
	Norvin Eitzen
	Including 2nd optional argument for file dump
	Added URL support "Not starting with HTTP
*/
#include	"cliserv.h"

int main(int argc, char *argv[])		/* T/TCP client */
{
	struct sockaddr_in	serv;
	char reply[REPLY];
	char *request;
	int sockfd, n;
	struct hostent *hp;
	char **p;
	char *cp;
	struct in_addr in;
	FILE *fp;
	int l;
	char *hostname;
	char buff[400];

	if ((argc != 2) && (argc != 3))
		err_quit("usage: tcpcli <address of server> [<file>]");

	if ( (sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
		err_sys("socket error");

	memset(&serv, sizeof(serv), 0);
	serv.sin_family	= AF_INET;
	
	/* form request[] ... */
	if(cp=strchr(argv[1], '/'))
	{
		*cp='\0';
		l = strlen(argv[1]);
		hostname = malloc(l+1);
		strcpy(hostname, argv[1]);
		*cp = '/';
		l=strlen(cp);
		request=malloc(l+1);
		strcpy(request, cp);
		printf("Hostname:%s\n", hostname);
		printf("Request:%s\n", request);
	}
	else {
		hostname = argv[1];
		request= "/";
	}
	sprintf(buff, "GET %s HTTP/1.1\r\nHost: %s\r\nConnection: close\r\n\r\n", 
		request, hostname);

	serv.sin_addr.s_addr = inet_addr(hostname);
	if(serv.sin_addr.s_addr == -1) {
		hp=gethostbyname2(hostname, AF_INET);
		if(hp!=NULL) {
			p=hp->h_addr_list;
			memcpy(&in.s_addr, *p, sizeof(in.s_addr));
			serv.sin_addr.s_addr = in.s_addr;
		}		
		else {
			printf("Can't Find Address %s\n", hostname);
			exit(2);
		}
	}
	serv.sin_port= htons(80);


	/* End form Request */
	if (sendto(sockfd, buff, sizeof(buff)-1, MSG_EOF,
			   (SA) &serv, sizeof(serv)) != sizeof(buff)-1)
		err_sys("sendto error");

	while ( (n = read_stream(sockfd, reply, REPLY)) > 0) {
		/* process "n" bytes of reply[] ... */
		if(argc ==2)
			write(1, reply, n); 
		else {
			if((fp=fopen(argv[2], "a"))==NULL) {
				printf("Error writing to %s\n", argv[2]);
				exit(3);
			}
			fwrite(reply, 1, n, fp);
			fclose(fp);
		}
		/* printf("%s", reply); */
	}
	if (n < 0)
		err_sys("read error");

	exit(0);
}

