/***************************************************************************************************
File:		common.c
Author:		Norvin Eitzen
Project:	EiTL
Licence:	GPL
Purpose: 	Used for a common libraries between source files.
****************************************************************************************************/

#include "../include/common.h"
#include <stdio.h>
#include <stdlib.h>

/* ==================================================================================================
Function:	Allocate
Parameters: 	len - integer - Amount of memory to allocate
Returns: 	Void Memory Pointer
Purpose:	Definition of a common memory allocation mechanism
Side Effects:	Memory of size "len" is allocated
Output:		None
=================================================================================================== */
void *Allocate (int len) {
        void *p = malloc(len);
        assert(p);
        return p;
}

