/*
File: queue.c
Description: Simple Dynamic Queue
Author : Norvin Eitzen
Date: Oct 19, 1999
*/

#include "../include/queue.h"
#include "../include/common.h"

queue initializeQueue(queue new) {
        /* Allocate memory for the node */

        new = Allocate(sizeof(struct queue_));

        new->front = Allocate(sizeof(struct nodetag_));
        new->rear = Allocate(sizeof(struct nodetag_));

        new->front = NULL;
        new->rear = NULL;

        /* Return the queue created */
        return new;
}

int fullQueue(queue q) {
        return 0;
}

int emptyQueue(queue q) {
        return(q->front == NULL);
}
queue insertQueue(queue q, char *data) {
        nodetag temp;
        /*printf("queue.c:qinsert(QUEUE, %s)...", data);*/
        temp = Allocate(sizeof(struct nodetag_));
     

        if(temp == NULL) {
                fprintf(stderr,"System is exhausted\n");
        } else {
                
                temp->item = Allocate(strlen(data));
                strcpy(temp->item,data);

                /* printf("INSERT:%s...", temp->item);  */

                temp->link = NULL;

                if(q->rear == NULL) {
                        q->front = temp;
                        q->rear = temp;
                        
                        /*strcpy(q->front->item, data);
                        
                        strcpy(q->rear->item, data);*/
                } else {
                        q->rear->link = temp;
                        q->rear = temp;

                       
                        /*if(q->rear->link != NULL)
                        strcpy(q->rear->link->item, data);
                                              
                        strcpy(q->rear->item, data);*/
                }
        }
        
        /*printf("Done\n");*/
}

char* removeQueue(queue q) {
        nodetag temp;
        char *data;

        /*printf("queue.c:qremove...");*/

        temp = Allocate(sizeof(struct nodetag_));

        if(q->front == NULL) {
                fprintf(stderr, "Attempt to remove from empty queue\n");
        } else {
                /*printf("queue.c:qremove:strcpy(data,
q->front->item)\n");
                printf("%s\n", q->front->item);*/
                /* strcpy(data, q->front->item); */
                data = q->front->item;
                /*printf("queue.c:qremove:temp=q->front\n");*/
                temp = q->front;
                /*printf("queue.c:qremove:q->front = temp->link\n");*/
                q->front = temp->link;
                /*printf("queue.c:qremove:free(temp)\n");*/
                free(temp);
                
                if(q->front == NULL) {
                        /*printf("queue.c:qremove:q->rear=NULL\n");*/
                        q->rear = NULL;
                }
        }
        /*printf("Done.\n");*/
        return data;        
}

void printQueue(queue q) {
        nodetag temp;
        temp = Allocate(sizeof(struct nodetag_));

        temp = q->front;
        printf("*** QUEUE PRINT ***\n");
        while(temp != NULL) {
                printf("%s\n", temp->item);
                temp = temp->link;
        }
        printf("*** END QUEUE PRINT ***\n");

}

