/* 
Based on TCP client
copyright (c) 1996 W. Richard Stevens.  All rights reserved.

Revised 1999 Norvin Eitzen

*/

#include 	"../include/cliserv.h"
#include	"../include/tcpcli.h"

int gethttppage(char *URL, char *filename)
{
	struct sockaddr_in	serv;
	char reply[REPLY];
	char *request;
	int sockfd, n;
	struct hostent *hp;
	char **p;
	char *cp;
	struct in_addr in;
	FILE *fp;
	int l;
	char *hostname;
	char buff[400];

	printf("Opening Raw Socket to %s\n",URL);
	if ( (sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
		err_sys("socket error");

	memset(&serv, sizeof(serv), 0);
	serv.sin_family	= AF_INET;
	
	/* form request[] ... */
	if(cp=strchr(URL, '/'))
	{
		*cp='\0';
		l = strlen(URL);
		hostname = malloc(l+1);
		strcpy(hostname, URL);
		*cp = '/';
		l=strlen(cp);
		request=malloc(l+1);
		strcpy(request, cp);
	}
	else {
		hostname = URL;
		request= "/";
	}
	sprintf(buff, "GET %s HTTP/1.1\r\nHost: %s\r\nConnection: close\r\n\r\n", 
		request, hostname);

	serv.sin_addr.s_addr = inet_addr(hostname);
	if(serv.sin_addr.s_addr == -1) {
		hp=gethostbyname2(hostname, AF_INET);
		if(hp!=NULL) {
			p=hp->h_addr_list;
			memcpy(&in.s_addr, *p, sizeof(in.s_addr));
			serv.sin_addr.s_addr = in.s_addr;
		}		
		else {
			printf("Can't Find Address %s\n", hostname);
			return(2);
		}
	}
	serv.sin_port= htons(80);

	
	/* End form Request */
	if (sendto(sockfd, buff, sizeof(buff)-1, MSG_EOF,
			   (SA) &serv, sizeof(serv)) != sizeof(buff)-1)
	{
		err_sys("sendto error");
		return(4);
	}
	

	/* Make sure file is deleted */
	if((fp=fopen(filename, "w"))==NULL) {
		printf("tcpcli.c:Error writing to %s\n",filename);
		return(3);
	}
	fclose(fp);


	printf("Processing Reply...\n");
	while ( (n = read_stream(sockfd, reply, REPLY)) > 0) {
		/* process "n" bytes of reply[] ... */

		if((fp=fopen(filename, "a"))==NULL) {
			printf("tcpcli.c:Error writing to %s\n",filename);
			return(3);
		}
		fwrite(reply, 1, n, fp);
		fclose(fp);
	}
	if (n < 0) {
		err_sys("read error");
		return(4);
	}
	printf("Socket Closed(Stable)\n");
	return(0);
}

